#include <fstream.h>
#include <strstrea.h>

void main(int argc, char **argv)
{
  char buf[200];
  if (argc < 3) return;
  ifstream in(argv[1]);
  ofstream out(argv[2]);

  if (!in || !out) return;

  for (int i = 0; i < 84; i++)
  {
    out << "fig <";
    for (int j = 0; j < 3; j++)
    {
      unsigned long u = 0;
      unsigned short v;
      for (int n = 0; n < 4; n++)
      {
        in >> v;
        u |= (long)v << (n * 8);
      }
      out.setf(0x0200);
      out << hex << '0';
      out.width(8);
      out.fill('0');
      out << u;
      out << "H,";
    }
    for (int j = 0; j < 3; j++)
    {
      int u;
      in >> u;
      out << dec;
      out << u;
      if (j < 2) out << ',';
      in >> u;
    }
    out << ">\n";
  }

  out.close();
  in.close();
}
