#include <graphics.h>
#include <iostream.h>
#include <conio.h>

int x = 0, y = 0;

char figures[5][4][4] = {{{2,2,2,0},
                          {2,0,0,0},
                          {0,0,0,0},
                          {0,0,0,0}},

                         {{0,3,0,0},
                          {3,3,0,0},
                          {3,0,0,0},
                          {0,0,0,0}},

                         {{0,4,0,0},
                          {4,4,0,0},
                          {0,4,0,0},
                          {0,0,0,0}},

                         {{0,7,0,0},
                          {7,7,0,0},
                          {0,0,0,0},
                          {0,0,0,0}},

                         {{8,0,0,0},
                          {0,0,0,0},
                          {0,0,0,0},
                          {0,0,0,0}}};

char plane[4][4] = {{0,0,0,0},
                    {0,0,0,0},
                    {0,0,0,0},
                    {0,0,0,0}};

void Draw(char d[4][4])
{
  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
    {
      if (d[i][j])
        setfillstyle(1, d[i][j]);
      else
        setfillstyle(1, 1);
      bar(x + j * 10, y + i * 10, x + (j + 1) * 10, y + (i + 1) * 10);
    }

  x += 50;
  if (x > 600)
  {
    x = 0;
    y += 50;
  }
}

bool ADD(int x, int y, char d[4][4])
{
  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
      if (d[i][j] && plane[i + y][j + x]) return false;

  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
      plane[i + y][j + x] |= d[i][j];

  return true;
}

void DelEntry(int x, int y, char d[4][4])
{
  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
      if (d[i][j]) plane[i + y][j + x] = 0;
}

void Rotate(char d[4][4])
{
  int w = 3, h = 2;

  for (int i = 0; i < h; i++)
    for (int j = 0; j < w; j++)
    {
      d[j][i] = d[h - 1 - i][w - 1 - j];
      d[h - 1 - i][w - 1 - j] = 0;
    }
}

void Build()
{
  for (int y1 = 0; y1 < 3; y1++)
    for (int x1 = 0; x1 < 2; x1++)
    {
      if (ADD(x1, y1, figures[0]))
      {
        for (int y2 = 0; y2 < 2; y2++)
          for (int x2 = 0; x2 < 3; x2++)
          {
            if (ADD(x2, y2, figures[1]))
            {
              for (int y3 = 0; y3 < 2; y3++)
                for (int x3 = 0; x3 < 3; x3++)
                {
                  if (ADD(x3, y3, figures[2]))
                  {
                    for (int y4 = 0; y4 < 3; y4++)
                      for (int x4 = 0; x4 < 3; x4++)
                      {
                        if (ADD(x4, y4, figures[3]))
                        {
                          for (int y5 = 0; y5 < 4; y5++)
                            for (int x5 = 0; x5 < 4; x5++)
                            {
                              if (ADD(x5, y5, figures[4]))
                              {
                                Draw(plane);
                                DelEntry(x5, y5, figures[4]);
                              }
                            }
                          DelEntry(x4, y4, figures[3]);
                        }
                      }
                    DelEntry(x3, y3, figures[2]);
                  }
                }
              DelEntry(x2, y2, figures[1]);
            }
          }
        DelEntry(x1, y1, figures[0]);
      }
    }
}

void main()
{
  int gd = DETECT, gm;

  registerbgidriver(EGAVGA_driver);
  initgraph(&gd, &gm, "");

//  Build();
  Draw(figures[0]);
  Rotate(figures[0]);
  Draw(figures[0]);

  getch();
  closegraph();
}
