#include <fstream.h>
#include <string.h>

struct List {
  char s[28];
  int num;
  List *next;
} *beg = NULL, *end = NULL;

void Add(char *s)
{
  List *p = beg;
  int count = 0;

  while (p != NULL)
  {
    if (!strcmp(p -> s, s))
    {
      p -> num++;
      count++;
    }
    p = p -> next;
  }

  if (count) return;

  List *l = new List;
  strcpy(l -> s, s);
  l -> num = 1;
  l -> next = NULL;

  if (beg == NULL)
    beg = l;
  else
    end -> next = l;
  end = l;
}

void Read(char *filename)
{
  ifstream in(filename);
  char s[28];

  in >> s;
  while (in && s[0])
  {
    Add(s);
    in >> s;
  }

  in.close();
}

void Write(char *filename)
{
  ofstream out(filename);
  List *p = beg;

  while (p != NULL)
  {
    out << p -> s << "\n";
    p = p -> next;
  }

  out.close();
}

void main(int argc, char **argv)
{
  if (argc < 2) return;

  Read(argv[1]);
  Write(argv[1]);
}
